@if (0)==(0) (if "%~1" neq "" (for /f "tokens=* delims=:" %%H in ('findstr.exe /bc:"::" "%~fs0"') do @echo(%%H)|more.com
  for %%C in (^"cscript.exe //nologo //e:jscript "%~fs0" ^") do @(set speak=%%~C&set speak_async=start /b %%~C))&goto :eof @end

var args=WScript.Arguments.Named, s=args('s'),
  v=parseInt(args('v')), r=parseInt(args('r')), p=parseInt(args('p')),
  n=args('n') && args('n').toLowerCase(), g=args('g'), l=parseInt(args('l'), 16),
  fs=new ActiveXObject('Scripting.FileSystemObject'),
  vc=new ActiveXObject('SAPI.SpVoice'), vt=vc.GetVoices(g && 'Gender='+g),
  isFilename=0x4, parseSapi=0x80, parseSsml=0x100;
if(v>-1 && v<100) vc.Volume=v;
if(r>-11 && r<11) vc.Rate=r;
if(p>0 && p<3) vc.Priority=p;
if(n || g || l) for(var i=0; i<vt.Count; ++i) {
  if(!((n && vt.Item(i).GetAttribute('Name').toLowerCase().indexOf(n)==-1) || (l && parseInt(vt.Item(i).GetAttribute('Language'), 16)!=l))) {
    vc.Voice=vt.Item(i);
    break;
  }
}
if(fs.FileExists(s)) {
  if(fs.GetExtensionName(s).toLowerCase()=='.wav') {
    var fs=new ActiveXObject('SAPI.SpFileStream');
    fs.Open(s);
    vc.SpeakStream(fs);
  }
  else if(s.toLowerCase()=='conin$') vc.Speak(WScript.StdIn.ReadAll(), parseSapi|parseSsml);
  else vc.Speak(fs.GetAbsolutePathName(s), isFilename|parseSapi|parseSsml);
  WScript.Quit();
}
vc.Speak(new ActiveXObject('WScript.Shell').Environment('Process')(s) || s, parseSapi|parseSsml);

/* --- help ---
::Call "speak.bat" once to initialize variables %speak% and %speak_async%.
::Use %speak% for synchronous and %speak_async% for asynchronous execution as
:: described here:
::%speak%|%speak_async%  /s:"<source>"  [/v:<volume>]  [/r:<rate>]
::         [/p:<priority>]  [/n:<voice name>]  [/g:<gender>]  [/l:<language ID>]
::
:: <source>      If <source> is the name of an existing .wav file then the
::                content of the file is played,
::               else if <source> is "CONIN$" then the text to be spoken is read
::                from the standard input stream,
::               else if <source> is the name of another existing file then the
::                content of the file is the text to be spoken,
::               else if <source> is the name of a defined environment variable
::                then the content of the variable is the text to be spoken,
::               else <source> is the text to be spoken.
::               The text to be spoken may consist of
::               - plain text,
::               - or SAPI XML TTS markup, - see:
::                https://docs.microsoft.com/en-us/previous-versions/windows/desktop/ee431815(v=vs.85)
::               - or SSML 1.0 markup. - see:
::                https://www.w3.org/TR/2004/REC-speech-synthesis-20040907/
:: <volume>      Percentage (0..100) of the currently set system volume to be
::                used. The default is 100. Has no effect for .wav files played.
:: <rate>        Speaking rate (-10..10) of the text to be spoken. The default
::                is 0. Has no effect for .wav files played.
:: <priority>    Priority level (0..2) of the voice.
::                0 (default) Normal voice. Streams spoken by a normal voice are
::                  appended to the voice queue.
::                1 Alert voice. An alert voice will interrupt a normal voice
::                  for the time the alert voice speaks.
::                2 Over voice. Streams spoken by an over voice don't interrupt
::                  other voices, but are merged with the voices of lower
::                  priorities.
:: <voice name>  Unique part of the name attribute of the voice token to be used
::                (such like "Zira" or "David").
:: <gender>      Gender of the voice token (either "male" or "female").
:: <language ID> Language identifier of the voice token. - see:
::                https://docs.microsoft.com/en-us/windows/win32/intl/language-identifier-constants-and-strings
::
::To explore installed voice tokens on your computer see registry key:
:: HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Speech\Voices\Tokens
::Values defined in the command line options are used to update the basic
:: settings of the voice object. Attributes specified in markup text take
:: priority over these settings though.
::If all values of the specified options /n, /g, and /l match at least one
:: installed voice token then the first matching voice token is used. Otherwise
:: the default voice token is used.
*/
